#Initializing variables and creating new objects
puts "Initializing database"

DataMapper::Logger.new($stdout, :debug)
DataMapper.setup(:default, 'sqlite:sqdatabase.sqlite3')
DataMapper::Model.raise_on_save_failure = true

class Element
  include DataMapper::Resource

  property :id, Serial
  property :height, Integer
  property :width, Integer
  property :length, Integer
  property :weight, Integer
  property :barcode, String
  property :imagefilename, String
end

DataMapper.finalize
DataMapper.auto_upgrade!

#Sample class
=begin
class Post
  include DataMapper::Resource

  property :id,         Serial   # An auto-increment integer key
  property :title,      String   # A varchar type string, for short strings
  property :body,       Text     # A text block, for longer string data.
  property :created_at, DateTime # A DateTime, for any date you might like.
end
=end