#Libraries
require 'socket'
require 'thread'
require 'dm-core'
require 'dm-migrations'

#Other classes
require 'database.rb'

class Communicator
  @client

  def handle(socket)
    @client = socket

    begin
      loop {
        rsize = @client.readpartial(4).unpack("N");
        rsize = Integer(rsize.join)
        flag = @client.readpartial(4).unpack("N");
        flag = Integer(flag.join)
        barcode = @client.readpartial(rsize);

        if flag == 101 then
          puts "Got request for " + barcode.to_s + " with size " + rsize.to_s + " and flag " + flag.to_s

          element = Element.first(:barcode => barcode)
          if element

            efs = File.size("files/" + element.imagefilename)
            efs = [efs].pack("N")

            msg = Array.new

            success = [102].pack("N")
            msg.push(success)
            
            eid = [element.id].pack("N")
            msg.push(eid)
            eheight = [element.height].pack("N")
            msg.push(eheight)
            ewidth = [element.width].pack("N")
            msg.push(ewidth)
            elength = [element.length].pack("N")
            msg.push(elength)
            eweight = [element.weight].pack("N")
            msg.push(eweight)

            msg.each do |item|
              @client.write(item)
            end
          
            @client.write(efs)

            File.open "files/" + element.imagefilename, "r" do |io|
              buffer = ""
              while buffer = io.read(1024)
                @client.write(buffer)
              end
            end

          else
            success = [103].pack("N")
            @client.write(success)
          end
        end
      }
    rescue
      puts $!, $@
      puts "Client from " + @client.peeraddr.to_s + " disconnected"
      @client.close                 # Disconnect from the client
    end

    puts "Client from " + @client.peeraddr.to_s + " disconnected"
    @client.close                 # Disconnect from the client
  end

  def sendtime()
    @client.puts(Time.now.ctime)  # Send the time to the client
  end
end

server = TCPServer.open(3000)  # Socket to listen on port 3000
loop {                         # Infinite loop: servers run forever

  puts "Waiting for new client"
  puts ""
  Thread.new(server.accept) { |newsocket|
    begin
      puts (Time.now.ctime)
      puts "New client connected from " + newsocket.peeraddr.to_s + " , initializing thread..."
      instance = Communicator.new()
      instance.handle(newsocket)
    rescue
      puts $!, $@
    end
  }
}

=begin
Snippets:
Convert buffer to integer array
sbuf = sbuf.to_s.each_char.map(&:to_i)

# @client.print(sbuf)
=end